MOD1FI ;mod1fix
 	ORG	5200H
 ENTRY	LD	HL,MESG
 	CALL	PRINT
 RESTART	LD	HL,ASKMSG
 	CALL	PRINT
 	LD	HL,STRING
 	LD	B,1
 	CALL	40H
 	LD	A,(HL)
 	SUB	30H
 	JR	C,ENTRY
 	CP	4
 	JR	NC,ENTRY
 	LD	C,1
 SETDRV	OR	A
 	JR	Z,HAVDRV
 	SLA	C
 	DEC	A
 	JR	SETDRV
 HAVDRV	LD	A,C
 	LD	(DRIVE),A
 	LD	HL,37ECH
 	CALL	SELECT
 	LD	(HL),0BH
 	CALL	DSKSLO
 RESWAIT	CALL	SELECT
 	BIT	0,(HL)
 	JR	NZ,RESWAIT
 	BIT	2,(HL)
 	JP	Z,ERROR
 	CALL	SELECT
 	LD	A,5
 	LD	(37EFH),A
 	LD	A,1BH
 	LD	(HL),A
 	CALL	DSKSLO
 SEEKWT	CALL	SELECT
 	BIT	0,(HL)
 	JR	NZ,SEEKWT
 	LD	DE,0500H
 	LD	BC,BUFFER
 READLP	CALL	READ
 	JP	NZ,ERROR
 	INC	E
 	LD	A,E
 	SUB	10
 	JR	NZ,READLP
 	LD	E,0
 	LD	BC,BUFFER
 WRITLP	CALL	WRITE
 	JP	NZ,ERROR
 	INC	E
 	LD	A,E
 	SUB	10
 	JR	NZ,WRITLP
 	LD	HL,FINMSG
 	CALL	PRINT
 	JP	RESTART
 DSKSLO	PUSH	BC
 	LD	B,12
 	DJNZ	$
 	POP	BC
 	RET
 SELECT	LD	A,(37ECH)
 	AND	80H
 	LD	A,0
 DRIVE	EQU	$-1
 	LD	(37E1H),A
 	RET	Z
 	PUSH	BC
 	LD	BC,0
 	CALL	60H
 	POP	BC
 	JR	SELECT
 READ	LD	HL,READIT
 	JR	IOCOMM
 WRITE	LD	HL,WRITEIT
 IOCOMM	LD	A,5
 	LD	(RETRY),A
 	LD	(IOCALL),HL
 IOLOOP	PUSH	BC
 	CALL	0
 IOCALL	EQU	$-2
 	POP	HL
 	RET	Z
 	LD	B,H
 	LD	C,L
 	EX	AF,AF'
 	LD	A,0
 RETRY	EQU	$-1
 	DEC	A
 	LD	(RETRY),A
 	JR	NZ,IOLOOP
 	EX	AF,AF'
 	RET
 PRINT	PUSH	HL
 PRTLP	LD	A,(HL)
 	INC	HL
 	CP	3
 	JR	Z,PRTDON
 	PUSH	DE
 	CALL	33H
 	POP	DE
 	CP	13
 	JR	NZ,PRTLP
 PRTDON	POP	HL
 	RET
 READIT	CALL	SELECT
 	LD	(37EEH),DE
 	LD	HL,37ECH
 	DI
 	LD	(HL),88H
 	PUSH	DE
 	LD	DE,37EFH
 	CALL	DSKSLO
 	JR	READ2
 READ1	RRCA
 	JR	NC,READ3
 READ2	LD	A,(HL)
 	BIT	1,A
 	JR	Z,READ1
 	LD	A,(DE)
 	LD	(BC),A
 	INC	BC
 	JR	READ2
 READ3	LD	A,(HL)
 	POP	DE
 	AND	9FH
 	RET
 WRITEIT	CALL	SELECT
 	LD	(37EEH),DE
 	LD	HL,37ECH
 	DI
 	LD	(HL),0A9H
 	PUSH	DE
 	LD	DE,37EFH
 	CALL	DSKSLO
 	JR	WRITE2
 WRITE1	RRCA
 	JR	NC,WRITE3
 WRITE2	LD	A,(HL)
 	BIT	1,A
 	JR	Z,WRITE1
 	LD	A,(BC)
 	LD	(DE),A
 	INC	BC
 	JR	WRITE2
 WRITE3	LD	A,(HL)
 	POP	DE
 	AND	0FCH
 	RET
 ERROR	LD	HL,ERMSG
 	CALL	PRINT
 	JP	RESTART
 MESG	DB	1CH,1FH
 	DB	'***  Read Protect Fix for I/III File Transfer Utility  ***',10
 	DB	'by Kim Watt - Breeze/QSD, Inc. - (214) 484-9428',10,10,13
 ASKMSG	DB	'Which Drive contains MOUNTED Disk to repair ? ',3
 FINMSG	DB	'Routine Completed OK !',13
 ERMSG	DB	'Disk ERROR !',13
 STRING	DS	5
 DBUFF	EQU	$&0FF00H
 BUFFER	EQU	DBUFF+100H
 	END	ENTRY
